#ifndef EEF_PRIVATE_TYPES_H
#define EEF_PRIVATE_TYPES_H

#if HAVE_CONFIG_H
#include "config.h"
#endif
#if HAVE_STDDEF_H
#include <stddef.h>
#endif
#if HAVE_WCHAR_H
#include <wchar.h>
#endif


/*! Identifiers for linked process symbols */
typedef enum eef_proctype_e {
    INITPROC,   /*!< this value corresponds to the plugin initialization function */
    RUNPROC,    /*!< this value corresponds to the plugin run function (get credentials) */
    TERMPROC,   /*!< this value corresponds to the plugin termination function */
    INTROPROC,  /*!< this value corresponds to the plugin introspect function */
    VERIFYPROC, /*!< this value corresponds to the plugin verification function */
    ENDOFPROCS  /*< this is the last enumeration value */
} eef_proctype_t;


/*! Argument types */
typedef enum {
  TYPE_NONE,
  TYPE_SCHAR,
  TYPE_UCHAR,
  TYPE_SHORT,
  TYPE_USHORT,
  TYPE_INT,
  TYPE_UINT,
  TYPE_LONGINT,
  TYPE_ULONGINT,
#ifdef HAVE_LONG_LONG_INT
  TYPE_LONGLONGINT,
  TYPE_ULONGLONGINT,
#endif
  TYPE_FLOAT,
  TYPE_DOUBLE,
#ifdef HAVE_LONG_DOUBLE
  TYPE_LONGDOUBLE,
#endif
  TYPE_CHAR,
#ifdef HAVE_WINT_T
  TYPE_WIDE_CHAR,
#endif
  TYPE_STRING,
#ifdef HAVE_WCHAR_T
  TYPE_WIDE_STRING,
#endif
  TYPE_POINTER,
  TYPE_COUNT_SCHAR_POINTER,
  TYPE_COUNT_SHORT_POINTER,
  TYPE_COUNT_INT_POINTER,
  TYPE_COUNT_LONGINT_POINTER,
#ifdef HAVE_LONG_LONG_INT
  TYPE_COUNT_LONGLONGINT_POINTER,
#endif
  TYPE_PEM,
  TYPE_X509,
  TYPE_STACK_OF_X509,
  TYPE_EVP_PKEY
} eef_arg_type;



#endif
